/*
	A basic extension of the java.awt.Frame class
 */

import java.awt.*;
import java.lang.*;
import java.lang.reflect.*;
//import java.util.*;

public class NativeClass extends Frame
{
    Object stateArray; // this is a "global" that'll be updated with state info
    
	public NativeClass()
	{
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setLayout(null);
		setVisible(false);
		setSize(insets().left + insets().right + 430,insets().top + insets().bottom + 270);
		button1 = new java.awt.Button();
		button1.setActionCommand("button");
		button1.setLabel("OpenSerial");
		button1.setBounds(insets().left + 24,insets().top + 24,96,36);
		button1.setBackground(new Color(12632256));
		add(button1);
		textField1 = new java.awt.TextField();
		textField1.setBounds(insets().left + 144,insets().top + 24,126,36);
		add(textField1);
		button2 = new java.awt.Button();
		button2.setActionCommand("button");
		button2.setLabel("Sonars on");
		button2.setBounds(insets().left + 24,insets().top + 96,96,33);
		button2.setBackground(new Color(12632256));
		add(button2);
		button3 = new java.awt.Button();
		button3.setActionCommand("button");
		button3.setLabel("Sonars off");
		button3.setBounds(insets().left + 24,insets().top + 144,96,29);
		button3.setBackground(new Color(12632256));
		add(button3);
		textField2 = new java.awt.TextField();
		textField2.setBounds(insets().left + 324,insets().top + 24,94,34);
		add(textField2);
		button4 = new java.awt.Button();
		button4.setActionCommand("button");
		button4.setLabel("stop!");
		button4.setBounds(insets().left + 300,insets().top + 204,81,46);
		button4.setBackground(new Color(12632256));
		add(button4);
		button5 = new java.awt.Button();
		button5.setActionCommand("button");
		button5.setLabel("go!");
		button5.setBounds(insets().left + 300,insets().top + 156,80,37);
		button5.setBackground(new Color(12632256));
		add(button5);
		setTitle("Untitled");
		//}}
		setVisible(true);

		//{{INIT_MENUS
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymMouse aSymMouse = new SymMouse();
		button1.addMouseListener(aSymMouse);
		button2.addMouseListener(aSymMouse);
		button3.addMouseListener(aSymMouse);
		button4.addMouseListener(aSymMouse);
		button5.addMouseListener(aSymMouse);
		//}}
		// allocate memory for the state array
		stateArray=Array.newInstance(Integer.TYPE, 23);
		
	}

	public NativeClass(String title)
	{
		this();
		setTitle(title);
	}

	public synchronized void show()
	{
		move(50, 50);
		super.show();
	}

	public void addNotify()
	{
	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();
	    
		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		setSize(insets().left + insets().right + d.width, insets().top + insets().bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets().left, insets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;

	//{{DECLARE_CONTROLS
	java.awt.Button button1;
	java.awt.TextField textField1;
	java.awt.Button button2;
	java.awt.Button button3;
	java.awt.TextField textField2;
	java.awt.Button button4;
	java.awt.Button button5;
	//}}

	//{{DECLARE_MENUS
	//}}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == NativeClass.this)
				Frame1_WindowClosing(event);
		}
	}
	
	void Frame1_WindowClosing(java.awt.event.WindowEvent event)
	{
		hide();		 // hide the Frame
	}

	class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mouseClicked(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == button1)
				button1_MouseClick(event);
			else if (object == button2)
				button2_MouseClick(event);
			else if (object == button3)
				button3_MouseClick(event);
			else if (object == button4)
				button4_MouseClick(event);
			else if (object == button5)
				button5_MouseClick(event);
		}
	}

	void button1_MouseClick(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		int returnval;
		Object newarray;
		newarray=Array.newInstance(Integer.TYPE, 5);
		Array.setInt(newarray, 0, -5);
		textField2.setText(Integer.toString(Array.getInt(newarray,0)));		
		returnval = openSerial();
		textField1.setText(Integer.toString(returnval));
	}
	void button2_MouseClick(java.awt.event.MouseEvent event)
	{
	    sonarsOn(this.stateArray);
	    
	    // show the reading of the front sonar //
	    textField2.setText(Integer.toString(Array.getInt(this.stateArray,1)));
	    
		// to do: code goes here.
	}

	void button3_MouseClick(java.awt.event.MouseEvent event)
	{
	    int returnval;
	    returnval = sonarsOff(this.stateArray);
		textField1.setText(Integer.toString(returnval));
	    
		// to do: code goes here.
	}
	
	// ********************************** //
	// the following are C language DLL calls! //
	// opens serial port, returns 0 if successful
	
	// make a test thing here that returns an array! //
	
	public native int openSerial();
	public native int closeSerial();
	
	// All of the below functions take an array that MUST be allocated
	// already, as a 23-element integer array in Java. See above for
	// examples of how to do that. Here is what gets returned in this array
	// index 0: return value of the last command
	// index 1 - 16: sonars 1 - 16 values (ranges in inches)
	// index 17: integrated X position of the robot
	// index 18: integrated Y position of the robot 
	// index 19: angle of the robot, 0 - 3600
	// index 20: right wheel measured velocity of the robot
	// index 21: left wheel measured velocity of the robot
	// index 22: bumper state of the robot-- if this is zero, no 
	//              bumper is depressed. Else, it will be greater than 0.
	
	// turns on all 16 sonars in default pattern
	public native int sonarsOn(Object stateArray);
	// turns off all sonars
	public native int sonarsOff(Object stateArray);
	public native int zero(Object stateArray); // zero the encoders
	public native int limp(Object stateArray); // limp the motors
	public native int confAc(int ta, int sa, int ra, Object stateArray); //configure accelerations
	public native int confTimeout(int timeout, Object stateArray); // configure motor timeout
	public native int getState(Object stateArray); // update the state array
	public native int rMove(int rightspeed, int leftspeed, Object stateArray);
	public native int confSonars(int rate, Object sonarOrder, int numSonars,Object stateArray);
	
	// .dll loading command //
	static {
	    System.loadLibrary("cscout");
	}

	

	void button4_MouseClick(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		int returnval;
		returnval = rMove(0,0,this.stateArray);
		textField1.setText(Integer.toString(returnval));
		
	}

	void button5_MouseClick(java.awt.event.MouseEvent event)
	{
		int returnval;
		returnval = rMove(10,10,this.stateArray);
		textField1.setText(Integer.toString(returnval));
		
	    
		// to do: code goes here.
	}
}
